zoukankan      html  css  js  c++  java
  • 剑指Offer——数组中重复的数字

    题目描述:

    在一个长度为n的数组里的所有数字都在0到n-1的范围内。 数组中某些数字是重复的,但不知道有几个数字是重复的。也不知道每个数字重复几次。请找出数组中任意一个重复的数字。 例如,如果输入长度为7的数组{2,3,1,0,2,5,3},那么对应的输出是第一个重复的数字2。


    分析:

    方法1:

    用map保存每个数字出现的次数。

    方法2:

    不需要额外的数组或者hash table来保存,题目里写了数组里数字的范围保证在0 ~ n-1 之间,
    所以可以利用现有数组设置标志,当一个数字被访问过后,可以设置对应位上的数+n,
    之后再遇到相同的数时,会发现对应位上的数已经大于等于n了,那么直接返回这个数即可。


    代码:

    方法1:

     1 class Solution {
     2 public:
     3     // Parameters:
     4     //        numbers:     an array of integers
     5     //        length:      the length of array numbers
     6     //        duplication: (Output) the duplicated number in the array number
     7     // Return value:       true if the input is valid, and there are some duplications in the array number
     8     //                     otherwise false
     9     bool duplicate(int numbers[], int length, int* duplication) {
    10         map<int, int> myMap;
    11         for(int i = 0; i < length; i++) {
    12             if(myMap[numbers[i]] == 1) {
    13                 *duplication = numbers[i];
    14                 return true;
    15             }
    16             myMap[numbers[i]]++;
    17         }
    18         return false;
    19     }
    20 };

    方法2:

     1 class Solution {
     2 public:
     3     // Parameters:
     4     //        numbers:     an array of integers
     5     //        length:      the length of array numbers
     6     //        duplication: (Output) the duplicated number in the array number
     7     // Return value:       true if the input is valid, and there are some duplications in the array number
     8     //                     otherwise false
     9     bool duplicate(int numbers[], int length, int* duplication) {
    10         for(int i = 0; i < length; i++) {
    11             int m = numbers[i];
    12             if(m >= length) {
    13                 m -= length;
    14                 if(numbers[m] == numbers[i]) {
    15                     *duplication = m;
    16                     return true;
    17                 }
    18             }
    19             if(numbers[m] >= length) {
    20                 *duplication = m;
    21                 return true;
    22             }
    23             numbers[m] += length;
    24         }
    25         return false;
    26     }
    27 };
  • 相关阅读:
    hdu 1025 lis 注意细节!!!【dp】
    简单的数据生成方法
    注意特殊情况!最长上升子序列!!poj2533
    括号序列问题 uva 1626 poj 1141【区间dp】
    UVa 10502【dp】
    hdu 1024 MAX Sum Plus Plus【dp】
    python 《核心编程》 1,2章
    c语言 文件链表实现最简单的学生管理系统
    Python和Python解释器
    计算机基础小结
  • 原文地址:https://www.cnblogs.com/jacen789/p/7747769.html
Copyright © 2011-2022 走看看